Ruby: pm_index_operator_write_node Struct Reference

Ruby 3.4.5p51 (2025-07-16 revision 20cda200d3ce092571d0b5d342dadca69636cb0f)

Data Fields
pm_index_operator_write_node Struct Reference

IndexOperatorWriteNode. More...

`#include <ast.h>`

## Data Fields
pm_node_t | base
| The embedded base node.
struct pm_node * | receiver
| IndexOperatorWriteNode#receiver.
pm_location_t | call_operator_loc
| IndexOperatorWriteNode#call_operator_loc.
pm_location_t | opening_loc
| IndexOperatorWriteNode#opening_loc.
struct pm_arguments_node * | arguments
| IndexOperatorWriteNode#arguments.
pm_location_t | closing_loc
| IndexOperatorWriteNode#closing_loc.
struct pm_block_argument_node * | block
| IndexOperatorWriteNode#block.
pm_constant_id_t | binary_operator
| IndexOperatorWriteNode#binary_operator.
pm_location_t | binary_operator_loc
| IndexOperatorWriteNode#binary_operator_loc.
struct pm_node * | value
| IndexOperatorWriteNode#value.
Data Fields inherited from pm_node
pm_node_type_t | type
| This represents the type of the node.
pm_node_flags_t | flags
| This represents any flags on the node.
uint32_t | node_id
| The unique identifier for this node, which is deterministic based on the source.
pm_location_t | location
| This is the location of the node in the source.

## Detailed Description

IndexOperatorWriteNode.

Represents the use of an assignment operator on a call to [].

    foo.bar[baz] += value
    ^^^^^^^^^^^^^^^^^^^^^

Type: PM_INDEX_OPERATOR_WRITE_NODE

Flags (pm_call_node_flags):

- PM_CALL_NODE_FLAGS_SAFE_NAVIGATION
- PM_CALL_NODE_FLAGS_VARIABLE_CALL
- PM_CALL_NODE_FLAGS_ATTRIBUTE_WRITE
- PM_CALL_NODE_FLAGS_IGNORE_VISIBILITY

Definition at line 4655 of file ast.h.

## Field Documentation

## ◆ arguments

struct pm_arguments_node* pm_index_operator_write_node::arguments

IndexOperatorWriteNode#arguments.

Definition at line 4678 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ base

pm_node_t pm_index_operator_write_node::base

The embedded base node.

Definition at line 4657 of file ast.h.

Referenced by pm_dump_json().

## ◆ binary_operator

pm_constant_id_t pm_index_operator_write_node::binary_operator

IndexOperatorWriteNode#binary_operator.

Definition at line 4693 of file ast.h.

Referenced by pm_dump_json().

## ◆ binary_operator_loc

pm_location_t pm_index_operator_write_node::binary_operator_loc

IndexOperatorWriteNode#binary_operator_loc.

Definition at line 4698 of file ast.h.

Referenced by pm_dump_json().

## ◆ block

struct pm_block_argument_node* pm_index_operator_write_node::block

IndexOperatorWriteNode#block.

Definition at line 4688 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ call_operator_loc

pm_location_t pm_index_operator_write_node::call_operator_loc

IndexOperatorWriteNode#call_operator_loc.

Definition at line 4668 of file ast.h.

Referenced by pm_dump_json().

## ◆ closing_loc

pm_location_t pm_index_operator_write_node::closing_loc

IndexOperatorWriteNode#closing_loc.

Definition at line 4683 of file ast.h.

Referenced by pm_dump_json().

## ◆ opening_loc

pm_location_t pm_index_operator_write_node::opening_loc

IndexOperatorWriteNode#opening_loc.

Definition at line 4673 of file ast.h.

Referenced by pm_dump_json().

## ◆ receiver

struct pm_node* pm_index_operator_write_node::receiver

IndexOperatorWriteNode#receiver.

Definition at line 4663 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ value

struct pm_node* pm_index_operator_write_node::value

IndexOperatorWriteNode#value.

Definition at line 4703 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

The documentation for this struct was generated from the following file:

- prism/ast.h